#include "preview.h"
#include "main.h"

#pragma warning(disable:4996)

using namespace Gdiplus;

char g_icon_dir[MAX_PATH];
char g_icon0_path[MAX_PATH];
char g_pic0_path[MAX_PATH];
char g_pic1_path[MAX_PATH];
HWND g_hPreviewWnd = NULL;

void SetIconDir(char *szIconDir)
{
	strncpy(g_icon_dir, szIconDir, MAX_PATH - 1);
}

void ShowPreviewWnd(int nMode)
{
	if (g_hPreviewWnd != NULL) {
		if (nMode == 0) {
			ShowWindow(g_hPreviewWnd, SW_HIDE);
		} else {
			ShowWindow(g_hPreviewWnd, SW_RESTORE);
		}
	}
}

void ClosePreview()
{
	if (g_hPreviewWnd)
	{
		SendMessage(g_hPreviewWnd, WM_CLOSE, 0, 0);
	}
}

//-------------------------------------------------------------------------------------------------
//      R[obN֐
//-------------------------------------------------------------------------------------------------
LRESULT CALLBACK DlgProcPreview(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uiMsg) {
	case WM_CLOSE:
		g_hPreviewWnd = NULL;
		EndDialog(hWnd, IDCANCEL);
        break;
	case WM_INITDIALOG:
		OnInitPreview(hWnd);
		return TRUE;
    case WM_PAINT:
		OnPrint(hWnd);
        break;
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDOK:
			return TRUE;
		case IDCANCEL:
			return TRUE;
		}
		break;
	default:
		break;
	}

	return FALSE;
}

void OnInitPreview(HWND hWnd)
{
	FILE *t;

	memset(g_icon0_path, 0, MAX_PATH);
	memset(g_pic0_path, 0, MAX_PATH);
	memset(g_pic1_path, 0, MAX_PATH);

	// ACR̐ݒ
	HICON hIconSm;
	hIconSm = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_ICON));
	SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIconSm);

	// ACRi[tH_̃t@Cǂݍ
	if (strlen(g_icon_dir) > 0) {
		strcpy(g_icon0_path, g_icon_dir);
		strcat(g_icon0_path, "ICON0.PNG");
		t = fopen(g_icon0_path, "rb");
		if (t)
		{
			fclose(t);
		}
		else
		{
			strcpy(g_icon0_path, g_exec_dir);
			strcat(g_icon0_path, "ICON0.PNG");
		}

		strcpy(g_pic0_path, g_icon_dir);
		strcat(g_pic0_path, "PIC0.PNG");
		t = fopen(g_pic0_path, "rb");
		if (t)
		{
			fclose(t);
		}
		else
		{
			strcpy(g_pic0_path, g_exec_dir);
			strcat(g_pic0_path, "PIC0.PNG");
		}

		strcpy(g_pic1_path, g_icon_dir);
		strcat(g_pic1_path, "PIC1.PNG");
		t = fopen(g_pic1_path, "rb");
		if (t)
		{
			fclose(t);
		}
		else
		{
			strcpy(g_pic1_path, g_exec_dir);
			strcat(g_pic1_path, "PIC1.PNG");
		}
	}
	else
	{
		strcpy(g_icon0_path, g_exec_dir);
		strcat(g_icon0_path, "ICON0.PNG");
		strcpy(g_pic0_path, g_exec_dir);
		strcat(g_pic0_path, "PIC0.PNG");
		strcpy(g_pic1_path, g_exec_dir);
		strcat(g_pic1_path, "PIC1.PNG");
	}

	// EBhEőOʂɕ\
	SetWindowPos(hWnd, HWND_TOPMOST , g_main_wnd_left, g_main_wnd_bottom, 0, 0, SWP_NOSIZE);

	g_hPreviewWnd = hWnd;
}

void OnPrint(HWND hWnd)
{
    HDC                 hdc;
	PAINTSTRUCT         ps;
    Gdiplus::Graphics*  foreGraph;           // \̈
	Gdiplus::Image*     image;               // 摜
    int                 x;                   // \ʒuij
    int                 y;                   // \ʒuicj
    int                 iOrgImgWidth;        // 摜TCYij
    int                 iOrgImgHeight;       // 摜TCYij
	WCHAR               wFilePath[MAX_PATH];

	hdc = BeginPaint(hWnd, &ps);
    
	foreGraph = new Graphics(hdc);

    //\[XBASE.PNGǂݍ
	image = LoadFromResource(IDR_BASE, "PNG", g_hInst);
	
	foreGraph->DrawImage(image, 0, 0, 480, 272);
	delete image;
    
	if (strlen(g_pic1_path) > 0) {
		mbstowcs(wFilePath, g_pic1_path, strlen(g_pic1_path) + 1);
		image = Image::FromFile(wFilePath);

		iOrgImgWidth = image->GetWidth();
		iOrgImgHeight = image->GetHeight();

		foreGraph->DrawImage(image, 0, 0, 480, 272);
		delete image;
	}

	if (strlen(g_pic0_path) > 0) {
		mbstowcs(wFilePath, g_pic0_path, strlen(g_pic0_path) + 1);
		image = Image::FromFile(wFilePath);

		iOrgImgWidth = image->GetWidth();
		iOrgImgHeight = image->GetHeight();

		x = 480 - 316;
		y = 272 - 186;

		foreGraph->DrawImage(image, x, y, 310, 180);
		delete image;
	}

	if (strlen(g_icon0_path) > 0) {
		mbstowcs(wFilePath, g_icon0_path, strlen(g_icon0_path) + 1);
		image = Image::FromFile(wFilePath);

		iOrgImgWidth = image->GetWidth();
		iOrgImgHeight = image->GetHeight();

		if (iOrgImgWidth > 144) {
			iOrgImgWidth = 144;
		}

		if (iOrgImgHeight > 80) {
			iOrgImgHeight = 80;
		}

		x = 92 - (iOrgImgWidth / 2);
		y = 136 - (iOrgImgHeight / 2);

		foreGraph->DrawImage(image, x, y, iOrgImgWidth, iOrgImgHeight);
		delete image;
	}

    EndPaint(hWnd, &ps);

	delete foreGraph;
}

Gdiplus::Image* LoadFromResource(UINT pResourceID, LPCTSTR pResourceType, HMODULE hInstance)
{
	LPCTSTR pResourceName;
	HRSRC hResource;
	DWORD dwResourceSize;
	const void* pResourceData;
	HGLOBAL hResourceBuffer;
	void* pResourceBuffer;
	IStream* pIStream;
	Gdiplus::Image* pImage;

    pResourceName = MAKEINTRESOURCE(pResourceID);
    hResource = FindResource(hInstance, pResourceName, pResourceType);
    dwResourceSize = SizeofResource(hInstance, hResource);
    pResourceData = LockResource(LoadResource(hInstance, hResource));
    hResourceBuffer = GlobalAlloc(GMEM_MOVEABLE, dwResourceSize);
    pResourceBuffer = GlobalLock(hResourceBuffer);

    CopyMemory(pResourceBuffer, pResourceData, dwResourceSize);
    pIStream = NULL;

    if(CreateStreamOnHGlobal(hResourceBuffer, FALSE, &pIStream)==S_OK)
    {
        pImage = Image::FromStream(pIStream);
        
        pIStream->Release();
        GlobalUnlock(hResourceBuffer);
        GlobalFree(hResourceBuffer);
        
        Status result = pImage->GetLastStatus();
        
        if(result == Gdiplus::Ok)
        {
            return pImage;
        }
        delete pImage;
    }
    GlobalUnlock(hResourceBuffer);
    GlobalFree(hResourceBuffer);

	return NULL;
}

